// Package env provides the [Paths] struct for efficiently building paths from
// the environment.
package env

import (
	"errors"
	"io/fs"
	"log"
	"os"
	"strconv"

	"hakurei.app/check"
	"hakurei.app/fhs"
	"hakurei.app/hst"
)

const VarRunNscd = fhs.Var + "run/nscd"

// Paths holds paths copied from the environment and is used to create [hst.Paths].
type Paths struct {
	// TempDir is returned by [os.TempDir].
	TempDir *check.Absolute
	// RuntimePath is copied from $XDG_RUNTIME_DIR.
	RuntimePath *check.Absolute
	// Whether [VarRunNscd] is a directory.
	HasNscd bool
}

// Copy expands [Paths] into [hst.Paths].
func (env *Paths) Copy(v *hst.Paths, userid int) {
	if env == nil || env.TempDir == nil || v == nil {
		panic("attempting to use an invalid Paths")
	}

	v.TempDir = env.TempDir
	v.SharePath = env.TempDir.Append("hakurei." + strconv.Itoa(userid))

	if env.RuntimePath == nil {
		// fall back to path in share since hakurei has no hard XDG dependency
		v.RuntimePath = v.SharePath.Append("compat")
	} else {
		v.RuntimePath = env.RuntimePath
	}
	v.RunDirPath = v.RuntimePath.Append("hakurei")
}

// CopyPaths returns a populated [Paths].
func CopyPaths() *Paths {
	return CopyPathsFunc(log.Fatalf, os.TempDir, os.Getenv, os.Stat)
}

// CopyPathsFunc returns a populated [Paths], using the provided [log.Fatalf],
// [os.TempDir], [os.Getenv] functions.
func CopyPathsFunc(
	fatalf func(format string, v ...any),
	tempdir func() string,
	getenv func(key string) string,
	stat func(name string) (fs.FileInfo, error),
) *Paths {
	const xdgRuntimeDir = "XDG_RUNTIME_DIR"

	var env Paths

	if tempDir, err := check.NewAbs(tempdir()); err != nil {
		fatalf("invalid TMPDIR: %v", err)
		panic("unreachable")
	} else {
		env.TempDir = tempDir
	}

	if a, err := check.NewAbs(getenv(xdgRuntimeDir)); err == nil {
		env.RuntimePath = a
	}

	if fi, err := stat(VarRunNscd); err != nil {
		if !errors.Is(err, fs.ErrNotExist) {
			fatalf("%v", err)
			panic("unreachable")
		}
	} else {
		env.HasNscd = fi.IsDir()
	}

	return &env
}
